> For the complete documentation index, see [llms.txt](https://docs.espressosys.com/network/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.espressosys.com/network/developer/rollup-developers/nitro/rollup-migration-guide.md).

# Mainnet 0 to Mainnet Upgrade

This guide applies to chains that integrated Espresso on Mainnet 0 using Nitro-style batch posting to a parent chain.

If you have a rollup using the Espresso network version 0 for confirmations, some changes are necessary in order to be compatible with version 1. These changes should be minimal. They must be completed before April 15, 2025 for the Decaf testnet. Mainnet launched on March 4, 2026. Rollups should complete this migration to remain compatible.

**Estimated Effort:** 1 engineer-day

## Rust Integrations

1. Update dependencies:

<pre class="language-toml"><code class="lang-toml">hotshot-types = { git = "https://github.com/EspressoSystems/espresso-network", default-features = false, tag = "20250412-dev-node-pos-preview" }
<strong>hotshot-query-service = { git = "https://github.com/espressosystems/espresso-network", tag = "20250412-dev-node-pos-preview" }
</strong>espresso-types = { git = "https://github.com/espressosystems/espresso-network", tag = "20250412-dev-node-pos-preview" }
</code></pre>

2. The following types have been moved to different modules, so you may have to adjust some import statements:

```rust
use hotshot_query_service::VidCommon;
use hotshot_types::{data::VidCommitment, light_client::hash_bytes_to_field};
```

## Go Integrations

1. Update the Espresso Go SDK:

```go-module
require github.com/EspressoSystems/espresso-network-go v0.0.35
```

## All Integrations

1. Change the API you use to connect to the Espresso query service from `v0`to `v1`(as in `https://query.decaf.testnet.espresso.network/v1`or `https://query.main.net.espresso.network/v1`.
2. Test your integration with the new version of Espresso. You can run a local Espresso network in `v1`mode using a fork of the Espresso dev node, with the usual options: `ghcr.io/espressosystems/espresso-sequencer/espresso-dev-node:20250412-dev-node-pos-preview`


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.espressosys.com/network/developer/rollup-developers/nitro/rollup-migration-guide.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
